#pragma once

#include <QObject>
#include <QJsonObject>
#include "sensor.h"

class OcupancySensorSource : public QObject
{
	Q_OBJECT
private:

	QString deviceMac_;
	QString device_;
	bool occupied = true;
	static constexpr unsigned timeoutMs = (15 * 60) * 1000;

public:
	explicit OcupancySensorSource(QObject *parent = nullptr, const QString& device = "wlan0",
	                              const QString& deviceMac = "60:BE:B5:25:8C:E0");

	void store(QJsonObject& json);
	void load(const QJsonObject& json);

public slots:
	void sensorEvent(Sensor sensor);

private slots:

	void Timeout();

signals:
	void stateChanged(Sensor sensor);
};
