#ifndef POLYNOMALACTORWIDGET_H
#define POLYNOMALACTORWIDGET_H

#include <QWidget>
#include "../../actors/polynomalactor.h"

namespace Ui
{
class PolynomalActorWidget;
}

class PolynomalActorWidget : public QWidget
{
	Q_OBJECT
	SensorStore* sensors_;
	std::shared_ptr<PolynomalActor> actor_;

public:
	explicit PolynomalActorWidget(std::shared_ptr<PolynomalActor> regulator, SensorStore* sensors = nullptr,
	                              QWidget *parent = nullptr);
	~PolynomalActorWidget();

private slots:

	void setPow();
	void setSensor(const QModelIndex &index);

private:
	Ui::PolynomalActorWidget *ui;
};

#endif // POLYNOMALACTORWIDGET_H
